/* 
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * File mous_int.h - Public interface to mouse interrupt handler for DOS 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * History :
 * Original Author : H. Hanemaayer (hhanemaa@cs.ruu.nl) 
 * (Mouse I/O based on code from vgalib vgamouse.c)
 * DOS port by Mihai Cartoaje ( moisemih@ift.ulaval.ca ).
 */

#ifndef MOUS_INT_H
#define MOUS_INT_H

#define MOUSE_LEFTBUTTON 4
#define MOUSE_MIDDLEBUTTON 2
#define MOUSE_RIGHTBUTTON 1

#define MOUSE_DEFAULTSAMPLERATE 150

/* Set event handler invoked by mouse_update(). */
typedef void (*__MouseHandler)(int button, int dx, int dy);

int  MouseInit( __MouseHandler Handler );
void MouseClose( void );
int  MouseUpdate( void );

#endif
