/* 
 * ASCD : copyright (c) Aley Keprt 1998-2001
 *
 * File speaker.c : 1bit beeper routines
 *
 * written by Aley Keprt 2000
 * SoundBlaster code taken from MPI
 * used under permission, copyright, all rights reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <pc.h>

#include "z80.h" 
#include "speaker.h"

typedef unsigned char byte;


static int SBerr;
static int SBport;
static int use_sb=1;


#define SBres      6
#define SBread   0xA
#define SBwrite  0xC
#define SBavail  0XE


static void SBwdsp(byte val) {
//
//pole bajt do DSP ipu
//pokud je DSP zatuhl, vysko ven
//pi chyb obsahuje DSP neproveden pkaz
//
 register unsigned wait=65535;

 if(SBerr) return;

 while(--wait&&(inp(SBport+SBwrite)&128));
 if(wait) outp(SBport+SBwrite,val); else SBerr=val;
}


int SBreset(void) {
//
//resetuje DSP ip - vrac 1=okay, 0=failed
//
 register unsigned pom;

 if(SBport) {
  outp(SBport+SBres,1);
  //3ms delay
  for(pom=0;pom<8;pom++) inp(0x388);
  outp(SBport+SBres,0);

  pom=65535;
  while(--pom&&(inp(SBport+SBavail)&128));
  SBerr=1;
  if(pom) {
   //ek na bajt 0xAA na data portu
   while(!(inp(SBport+SBavail)&128));
   if(inp(SBport+SBread)==0xaa) SBerr=0;
  }
 }
 return !SBerr;
}


//-----------------------------------------------------------------------------


void SBdetect(void) {
//
//cannot be used together with AY8910 emulation!
//
/*
  const char *blaster=getenv("BLASTER");
  if(!use_sb || !blaster || getenv("CTSYN")) return;
  if((blaster[0]|32)=='a') {
    SBport=strtol(blaster+1,0,16);
    if(SBport<0x100) SBport=0;
  }
*/
}


//-----------------------------------------------------------------------------


void EnableSB(int state) {
  use_sb=state;
  if(!use_sb) SBport=0;
}


void SpeakerOn(void) {
  if(!SBport) {
    SBdetect();
    if(SBport) SBreset();
  }
}


void SpeakerOff(void) {
  if(SBport) {
    SBreset();
  } else {
    outportb(0x61, inportb(0x61) & ~3);
  }
}


void SpeakerPlay(value) {
  if(SBport) {
    //SB
    SBwdsp(0x10);
    SBwdsp(64+value*128);
  } else {
    //speaker
    if(value) outportb(0x61, inportb(0x61) | 2);
    else outportb(0x61, inportb(0x61) & ~3);
  }
}

