/* 
 * ASCD : copyright (c) Aley Keprt 1998-2001
 *
 * Header file resource.h : Configuration data
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef _RESOURCE_H
#define _RESOURCE_H


typedef enum {  //emulation mode
  EM_Sam,
  EM_48k,
  EM_128k
} EM;


//---------------------------------------------------------------------------


#define INT int
#define BOOL int
#define TEXT char*
#define item(type,name,def,switch,help) type name;


typedef struct {
#include "cfg_vars.h"
} CFG;


extern CFG cfg;


/* Macros for quick access to the resource block (defined in resource.c) */
#define GetCfg(field) (cfg.field)
#define SetCfg(field,value) (cfg.field = (value))
#define SetCfgStr(field,value) (strncpy(cfg.field,(value),260))


void init_cfg(int argc, char **argvp);

void list_switches(void);


#endif
